import { Component, Input } from '@angular/core';
import { DetailsService } from 'src/services/details/details.service';
import { Attribute } from 'src/interfaces/attribute';

@Component({
  selector: 'app-attribute-details',
  templateUrl: './attribute-details.component.html',
  styleUrl: './attribute-details.component.scss',
})
export class AttributeDetailsComponent {
  public constructor(public detailsService: DetailsService) {}
  @Input() public attribute!: Attribute;
  @Input() public modifier!: string;

  public skillsTable: any = {
    strength: ['Athletik'],
    dexterity: ['Akrobatik', 'Fingerfertigkeit', 'Heimlichkeit'],
    constitution: [],
    intelligence: [
      'Arkana',
      'Geschichte',
      'Nachforschung',
      'Naturkunde',
      'Religion',
    ],
    wisdom: [
      'Tierkunde',
      'Motiv erkennen',
      'Heilkunde',
      'Wahrnehmung',
      'Überlebenskunde',
    ],
    charisma: ['Täuschung', 'Einschüchterung', 'Auftreten', 'Überzeugung'],
  };
}
